/* 0.9.7.2 on Sat Apr 11 01:24:03 2009 */

#define PY_SSIZE_T_CLEAN
#include "Python.h"
#include "structmember.h"
#ifndef PY_LONG_LONG
  #define PY_LONG_LONG LONG_LONG
#endif
#if PY_VERSION_HEX < 0x02050000
  typedef int Py_ssize_t;
  #define PY_SSIZE_T_MAX INT_MAX
  #define PY_SSIZE_T_MIN INT_MIN
  #define PyInt_FromSsize_t(z) PyInt_FromLong(z)
  #define PyInt_AsSsize_t(o)	PyInt_AsLong(o)
#endif
#ifndef WIN32
  #ifndef __stdcall
    #define __stdcall
  #endif
  #ifndef __cdecl
    #define __cdecl
  #endif
#endif
#ifdef __cplusplus
#define __PYX_EXTERN_C extern "C"
#else
#define __PYX_EXTERN_C extern
#endif
#include <math.h>
#include "pss.h"


typedef struct {PyObject **p; char *s;} __Pyx_InternTabEntry; /*proto*/
typedef struct {PyObject **p; char *s; long n;} __Pyx_StringTabEntry; /*proto*/

static PyObject *__pyx_m;
static PyObject *__pyx_b;
static int __pyx_lineno;
static char *__pyx_filename;
static char **__pyx_f;

static void __Pyx_Raise(PyObject *type, PyObject *value, PyObject *tb); /*proto*/

static PyObject *__Pyx_GetName(PyObject *dict, PyObject *name); /*proto*/

static int __Pyx_InternStrings(__Pyx_InternTabEntry *t); /*proto*/

static int __Pyx_InitStrings(__Pyx_StringTabEntry *t); /*proto*/

static void __Pyx_AddTraceback(char *funcname); /*proto*/

/* Declarations from sound */

static PyObject *__pyx_k1;
static PyObject *__pyx_k2;
static PyObject *__pyx_k3;
static PyObject *__pyx_k4;
static PyObject *__pyx_k5;
static PyObject *__pyx_k6;
static PyObject *__pyx_k7;


/* Implementation of sound */

static PyObject *__pyx_f_5sound_check_error(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_5sound_check_error(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_e;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  int __pyx_2;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  __pyx_v_e = Py_None; Py_INCREF(Py_None);

  /* "/home/tom/ab/renpy/module/sound.pyx":54 */
  __pyx_1 = PyString_FromString(PSS_get_error()); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 54; goto __pyx_L1;}
  Py_DECREF(__pyx_v_e);
  __pyx_v_e = __pyx_1;
  __pyx_1 = 0;

  /* "/home/tom/ab/renpy/module/sound.pyx":55 */
  __pyx_2 = PyObject_IsTrue(__pyx_v_e); if (__pyx_2 < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 55; goto __pyx_L1;}
  if (__pyx_2) {
    __Pyx_Raise(PyExc_Exception, __pyx_v_e, 0);
    {__pyx_filename = __pyx_f[0]; __pyx_lineno = 56; goto __pyx_L1;}
    goto __pyx_L2;
  }
  __pyx_L2:;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("sound.check_error");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_e);
  return __pyx_r;
}

static PyObject *__pyx_n_check_error;

static PyObject *__pyx_k8p;

static char __pyx_k8[] = "Could not create RWops.";

static PyObject *__pyx_f_5sound_play(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_5sound_play(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_channel = 0;
  PyObject *__pyx_v_file = 0;
  PyObject *__pyx_v_name = 0;
  PyObject *__pyx_v_paused = 0;
  PyObject *__pyx_v_fadein = 0;
  PyObject *__pyx_v_tight = 0;
  struct SDL_RWops *__pyx_v_rw;
  PyObject *__pyx_v_pause;
  PyObject *__pyx_r;
  int __pyx_1;
  PyObject *__pyx_2 = 0;
  char *__pyx_3;
  int __pyx_4;
  int __pyx_5;
  int __pyx_6;
  PyObject *__pyx_7 = 0;
  static char *__pyx_argnames[] = {"channel","file","name","paused","fadein","tight",0};
  __pyx_v_paused = __pyx_k1;
  __pyx_v_fadein = __pyx_k2;
  __pyx_v_tight = __pyx_k3;
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "OOO|OOO", __pyx_argnames, &__pyx_v_channel, &__pyx_v_file, &__pyx_v_name, &__pyx_v_paused, &__pyx_v_fadein, &__pyx_v_tight)) return 0;
  Py_INCREF(__pyx_v_channel);
  Py_INCREF(__pyx_v_file);
  Py_INCREF(__pyx_v_name);
  Py_INCREF(__pyx_v_paused);
  Py_INCREF(__pyx_v_fadein);
  Py_INCREF(__pyx_v_tight);
  __pyx_v_pause = Py_None; Py_INCREF(Py_None);

  /* "/home/tom/ab/renpy/module/sound.pyx":61 */
  __pyx_v_rw = RWopsFromPythonThreaded(__pyx_v_file);

  /* "/home/tom/ab/renpy/module/sound.pyx":63 */
  __pyx_1 = (__pyx_v_rw == NULL);
  if (__pyx_1) {
    __Pyx_Raise(PyExc_Exception, __pyx_k8p, 0);
    {__pyx_filename = __pyx_f[0]; __pyx_lineno = 64; goto __pyx_L1;}
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/tom/ab/renpy/module/sound.pyx":66 */
  __pyx_1 = PyObject_IsTrue(__pyx_v_paused); if (__pyx_1 < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 66; goto __pyx_L1;}
  if (__pyx_1) {
    __pyx_2 = PyInt_FromLong(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 67; goto __pyx_L1;}
    Py_DECREF(__pyx_v_pause);
    __pyx_v_pause = __pyx_2;
    __pyx_2 = 0;
    goto __pyx_L3;
  }
  /*else*/ {
    __pyx_2 = PyInt_FromLong(0); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 69; goto __pyx_L1;}
    Py_DECREF(__pyx_v_pause);
    __pyx_v_pause = __pyx_2;
    __pyx_2 = 0;
  }
  __pyx_L3:;

  /* "/home/tom/ab/renpy/module/sound.pyx":71 */
  __pyx_1 = PyObject_IsTrue(__pyx_v_tight); if (__pyx_1 < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 71; goto __pyx_L1;}
  if (__pyx_1) {
    __pyx_2 = PyInt_FromLong(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 72; goto __pyx_L1;}
    Py_DECREF(__pyx_v_tight);
    __pyx_v_tight = __pyx_2;
    __pyx_2 = 0;
    goto __pyx_L4;
  }
  /*else*/ {
    __pyx_2 = PyInt_FromLong(0); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 74; goto __pyx_L1;}
    Py_DECREF(__pyx_v_tight);
    __pyx_v_tight = __pyx_2;
    __pyx_2 = 0;
  }
  __pyx_L4:;

  /* "/home/tom/ab/renpy/module/sound.pyx":76 */
  __pyx_1 = PyInt_AsLong(__pyx_v_channel); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 76; goto __pyx_L1;}
  __pyx_3 = PyString_AsString(__pyx_v_name); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 76; goto __pyx_L1;}
  __pyx_4 = PyInt_AsLong(__pyx_v_fadein); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 76; goto __pyx_L1;}
  __pyx_5 = PyInt_AsLong(__pyx_v_tight); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 76; goto __pyx_L1;}
  __pyx_6 = PyInt_AsLong(__pyx_v_pause); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 76; goto __pyx_L1;}
  PSS_play(__pyx_1,__pyx_v_rw,__pyx_3,__pyx_v_name,__pyx_4,__pyx_5,__pyx_6);

  /* "/home/tom/ab/renpy/module/sound.pyx":77 */
  __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n_check_error); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 77; goto __pyx_L1;}
  __pyx_7 = PyObject_CallObject(__pyx_2, 0); if (!__pyx_7) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 77; goto __pyx_L1;}
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  Py_DECREF(__pyx_7); __pyx_7 = 0;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_7);
  __Pyx_AddTraceback("sound.play");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_pause);
  Py_DECREF(__pyx_v_channel);
  Py_DECREF(__pyx_v_file);
  Py_DECREF(__pyx_v_name);
  Py_DECREF(__pyx_v_paused);
  Py_DECREF(__pyx_v_fadein);
  Py_DECREF(__pyx_v_tight);
  return __pyx_r;
}

static PyObject *__pyx_f_5sound_queue(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_5sound_queue(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_channel = 0;
  PyObject *__pyx_v_file = 0;
  PyObject *__pyx_v_name = 0;
  PyObject *__pyx_v_fadein = 0;
  PyObject *__pyx_v_tight = 0;
  struct SDL_RWops *__pyx_v_rw;
  PyObject *__pyx_r;
  int __pyx_1;
  PyObject *__pyx_2 = 0;
  char *__pyx_3;
  int __pyx_4;
  int __pyx_5;
  PyObject *__pyx_6 = 0;
  static char *__pyx_argnames[] = {"channel","file","name","fadein","tight",0};
  __pyx_v_fadein = __pyx_k4;
  __pyx_v_tight = __pyx_k5;
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "OOO|OO", __pyx_argnames, &__pyx_v_channel, &__pyx_v_file, &__pyx_v_name, &__pyx_v_fadein, &__pyx_v_tight)) return 0;
  Py_INCREF(__pyx_v_channel);
  Py_INCREF(__pyx_v_file);
  Py_INCREF(__pyx_v_name);
  Py_INCREF(__pyx_v_fadein);
  Py_INCREF(__pyx_v_tight);

  /* "/home/tom/ab/renpy/module/sound.pyx":82 */
  __pyx_v_rw = RWopsFromPythonThreaded(__pyx_v_file);

  /* "/home/tom/ab/renpy/module/sound.pyx":84 */
  __pyx_1 = PyObject_IsTrue(__pyx_v_tight); if (__pyx_1 < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 84; goto __pyx_L1;}
  if (__pyx_1) {
    __pyx_2 = PyInt_FromLong(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 85; goto __pyx_L1;}
    Py_DECREF(__pyx_v_tight);
    __pyx_v_tight = __pyx_2;
    __pyx_2 = 0;
    goto __pyx_L2;
  }
  /*else*/ {
    __pyx_2 = PyInt_FromLong(0); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 87; goto __pyx_L1;}
    Py_DECREF(__pyx_v_tight);
    __pyx_v_tight = __pyx_2;
    __pyx_2 = 0;
  }
  __pyx_L2:;

  /* "/home/tom/ab/renpy/module/sound.pyx":89 */
  __pyx_1 = PyInt_AsLong(__pyx_v_channel); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 89; goto __pyx_L1;}
  __pyx_3 = PyString_AsString(__pyx_v_name); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 89; goto __pyx_L1;}
  __pyx_4 = PyInt_AsLong(__pyx_v_fadein); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 89; goto __pyx_L1;}
  __pyx_5 = PyInt_AsLong(__pyx_v_tight); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 89; goto __pyx_L1;}
  PSS_queue(__pyx_1,__pyx_v_rw,__pyx_3,__pyx_v_name,__pyx_4,__pyx_5);

  /* "/home/tom/ab/renpy/module/sound.pyx":90 */
  __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n_check_error); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 90; goto __pyx_L1;}
  __pyx_6 = PyObject_CallObject(__pyx_2, 0); if (!__pyx_6) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 90; goto __pyx_L1;}
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  Py_DECREF(__pyx_6); __pyx_6 = 0;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_6);
  __Pyx_AddTraceback("sound.queue");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_channel);
  Py_DECREF(__pyx_v_file);
  Py_DECREF(__pyx_v_name);
  Py_DECREF(__pyx_v_fadein);
  Py_DECREF(__pyx_v_tight);
  return __pyx_r;
}

static PyObject *__pyx_f_5sound_stop(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_5sound_stop(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_channel = 0;
  PyObject *__pyx_r;
  int __pyx_1;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  static char *__pyx_argnames[] = {"channel",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O", __pyx_argnames, &__pyx_v_channel)) return 0;
  Py_INCREF(__pyx_v_channel);

  /* "/home/tom/ab/renpy/module/sound.pyx":93 */
  __pyx_1 = PyInt_AsLong(__pyx_v_channel); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 93; goto __pyx_L1;}
  PSS_stop(__pyx_1);

  /* "/home/tom/ab/renpy/module/sound.pyx":94 */
  __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n_check_error); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 94; goto __pyx_L1;}
  __pyx_3 = PyObject_CallObject(__pyx_2, 0); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 94; goto __pyx_L1;}
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  Py_DECREF(__pyx_3); __pyx_3 = 0;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  __Pyx_AddTraceback("sound.stop");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_channel);
  return __pyx_r;
}

static PyObject *__pyx_f_5sound_dequeue(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_5sound_dequeue(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_channel = 0;
  PyObject *__pyx_v_even_tight = 0;
  PyObject *__pyx_r;
  int __pyx_1;
  int __pyx_2;
  static char *__pyx_argnames[] = {"channel","even_tight",0};
  __pyx_v_even_tight = __pyx_k6;
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O|O", __pyx_argnames, &__pyx_v_channel, &__pyx_v_even_tight)) return 0;
  Py_INCREF(__pyx_v_channel);
  Py_INCREF(__pyx_v_even_tight);
  __pyx_1 = PyInt_AsLong(__pyx_v_channel); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 97; goto __pyx_L1;}
  __pyx_2 = PyInt_AsLong(__pyx_v_even_tight); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 97; goto __pyx_L1;}
  PSS_dequeue(__pyx_1,__pyx_2);

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  __Pyx_AddTraceback("sound.dequeue");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_channel);
  Py_DECREF(__pyx_v_even_tight);
  return __pyx_r;
}

static PyObject *__pyx_f_5sound_queue_depth(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_5sound_queue_depth(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_channel = 0;
  PyObject *__pyx_r;
  int __pyx_1;
  PyObject *__pyx_2 = 0;
  static char *__pyx_argnames[] = {"channel",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O", __pyx_argnames, &__pyx_v_channel)) return 0;
  Py_INCREF(__pyx_v_channel);
  __pyx_1 = PyInt_AsLong(__pyx_v_channel); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 100; goto __pyx_L1;}
  __pyx_2 = PyInt_FromLong(PSS_queue_depth(__pyx_1)); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 100; goto __pyx_L1;}
  __pyx_r = __pyx_2;
  __pyx_2 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  __Pyx_AddTraceback("sound.queue_depth");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_channel);
  return __pyx_r;
}

static PyObject *__pyx_f_5sound_playing_name(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_5sound_playing_name(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_channel = 0;
  PyObject *__pyx_r;
  int __pyx_1;
  PyObject *__pyx_2 = 0;
  static char *__pyx_argnames[] = {"channel",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O", __pyx_argnames, &__pyx_v_channel)) return 0;
  Py_INCREF(__pyx_v_channel);
  __pyx_1 = PyInt_AsLong(__pyx_v_channel); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 103; goto __pyx_L1;}
  __pyx_2 = PSS_playing_name(__pyx_1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 103; goto __pyx_L1;}
  __pyx_r = __pyx_2;
  __pyx_2 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  __Pyx_AddTraceback("sound.playing_name");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_channel);
  return __pyx_r;
}

static PyObject *__pyx_f_5sound_pause(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_5sound_pause(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_channel = 0;
  PyObject *__pyx_r;
  int __pyx_1;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  static char *__pyx_argnames[] = {"channel",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O", __pyx_argnames, &__pyx_v_channel)) return 0;
  Py_INCREF(__pyx_v_channel);

  /* "/home/tom/ab/renpy/module/sound.pyx":106 */
  __pyx_1 = PyInt_AsLong(__pyx_v_channel); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 106; goto __pyx_L1;}
  PSS_pause(__pyx_1,1);

  /* "/home/tom/ab/renpy/module/sound.pyx":107 */
  __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n_check_error); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 107; goto __pyx_L1;}
  __pyx_3 = PyObject_CallObject(__pyx_2, 0); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 107; goto __pyx_L1;}
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  Py_DECREF(__pyx_3); __pyx_3 = 0;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  __Pyx_AddTraceback("sound.pause");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_channel);
  return __pyx_r;
}

static PyObject *__pyx_f_5sound_unpause(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_5sound_unpause(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_channel = 0;
  PyObject *__pyx_r;
  int __pyx_1;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  static char *__pyx_argnames[] = {"channel",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O", __pyx_argnames, &__pyx_v_channel)) return 0;
  Py_INCREF(__pyx_v_channel);

  /* "/home/tom/ab/renpy/module/sound.pyx":110 */
  __pyx_1 = PyInt_AsLong(__pyx_v_channel); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 110; goto __pyx_L1;}
  PSS_pause(__pyx_1,0);

  /* "/home/tom/ab/renpy/module/sound.pyx":111 */
  __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n_check_error); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 111; goto __pyx_L1;}
  __pyx_3 = PyObject_CallObject(__pyx_2, 0); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 111; goto __pyx_L1;}
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  Py_DECREF(__pyx_3); __pyx_3 = 0;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  __Pyx_AddTraceback("sound.unpause");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_channel);
  return __pyx_r;
}

static PyObject *__pyx_f_5sound_unpause_all(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_5sound_unpause_all(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  PSS_unpause_all();

  __pyx_r = Py_None; Py_INCREF(Py_None);
  return __pyx_r;
}

static PyObject *__pyx_f_5sound_fadeout(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_5sound_fadeout(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_channel = 0;
  PyObject *__pyx_v_ms = 0;
  PyObject *__pyx_r;
  int __pyx_1;
  int __pyx_2;
  PyObject *__pyx_3 = 0;
  PyObject *__pyx_4 = 0;
  static char *__pyx_argnames[] = {"channel","ms",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "OO", __pyx_argnames, &__pyx_v_channel, &__pyx_v_ms)) return 0;
  Py_INCREF(__pyx_v_channel);
  Py_INCREF(__pyx_v_ms);

  /* "/home/tom/ab/renpy/module/sound.pyx":117 */
  __pyx_1 = PyInt_AsLong(__pyx_v_channel); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 117; goto __pyx_L1;}
  __pyx_2 = PyInt_AsLong(__pyx_v_ms); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 117; goto __pyx_L1;}
  PSS_fadeout(__pyx_1,__pyx_2);

  /* "/home/tom/ab/renpy/module/sound.pyx":118 */
  __pyx_3 = __Pyx_GetName(__pyx_m, __pyx_n_check_error); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 118; goto __pyx_L1;}
  __pyx_4 = PyObject_CallObject(__pyx_3, 0); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 118; goto __pyx_L1;}
  Py_DECREF(__pyx_3); __pyx_3 = 0;
  Py_DECREF(__pyx_4); __pyx_4 = 0;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_4);
  __Pyx_AddTraceback("sound.fadeout");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_channel);
  Py_DECREF(__pyx_v_ms);
  return __pyx_r;
}

static PyObject *__pyx_f_5sound_busy(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_5sound_busy(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_channel = 0;
  PyObject *__pyx_r;
  int __pyx_1;
  PyObject *__pyx_2 = 0;
  static char *__pyx_argnames[] = {"channel",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O", __pyx_argnames, &__pyx_v_channel)) return 0;
  Py_INCREF(__pyx_v_channel);
  __pyx_1 = PyInt_AsLong(__pyx_v_channel); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 121; goto __pyx_L1;}
  __pyx_2 = PyInt_FromLong((PSS_get_pos(__pyx_1) != (-1))); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 121; goto __pyx_L1;}
  __pyx_r = __pyx_2;
  __pyx_2 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  __Pyx_AddTraceback("sound.busy");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_channel);
  return __pyx_r;
}

static PyObject *__pyx_f_5sound_get_pos(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_5sound_get_pos(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_channel = 0;
  PyObject *__pyx_r;
  int __pyx_1;
  PyObject *__pyx_2 = 0;
  static char *__pyx_argnames[] = {"channel",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O", __pyx_argnames, &__pyx_v_channel)) return 0;
  Py_INCREF(__pyx_v_channel);
  __pyx_1 = PyInt_AsLong(__pyx_v_channel); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 124; goto __pyx_L1;}
  __pyx_2 = PyInt_FromLong(PSS_get_pos(__pyx_1)); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 124; goto __pyx_L1;}
  __pyx_r = __pyx_2;
  __pyx_2 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  __Pyx_AddTraceback("sound.get_pos");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_channel);
  return __pyx_r;
}

static PyObject *__pyx_f_5sound_set_volume(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_5sound_set_volume(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_channel = 0;
  PyObject *__pyx_v_volume = 0;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  int __pyx_2;
  PyObject *__pyx_3 = 0;
  PyObject *__pyx_4 = 0;
  float __pyx_5;
  static char *__pyx_argnames[] = {"channel","volume",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "OO", __pyx_argnames, &__pyx_v_channel, &__pyx_v_volume)) return 0;
  Py_INCREF(__pyx_v_channel);
  Py_INCREF(__pyx_v_volume);

  /* "/home/tom/ab/renpy/module/sound.pyx":127 */
  __pyx_1 = PyInt_FromLong(0); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 127; goto __pyx_L1;}
  if (PyObject_Cmp(__pyx_v_volume, __pyx_1, &__pyx_2) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 127; goto __pyx_L1;}
  __pyx_2 = __pyx_2 == 0;
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  if (__pyx_2) {
    __pyx_2 = PyInt_AsLong(__pyx_v_channel); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 128; goto __pyx_L1;}
    PSS_set_volume(__pyx_2,0);
    goto __pyx_L2;
  }
  /*else*/ {
    __pyx_2 = PyInt_AsLong(__pyx_v_channel); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 130; goto __pyx_L1;}
    __pyx_1 = PyInt_FromLong(10); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 130; goto __pyx_L1;}
    __pyx_3 = PyNumber_Power(__pyx_1, __pyx_v_volume, Py_None); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 130; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    __pyx_1 = PyInt_FromLong(10); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 130; goto __pyx_L1;}
    __pyx_4 = PyNumber_Divide(__pyx_3, __pyx_1); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 130; goto __pyx_L1;}
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    __pyx_5 = PyFloat_AsDouble(__pyx_4); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 130; goto __pyx_L1;}
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    PSS_set_volume(__pyx_2,__pyx_5);
  }
  __pyx_L2:;

  /* "/home/tom/ab/renpy/module/sound.pyx":132 */
  __pyx_3 = __Pyx_GetName(__pyx_m, __pyx_n_check_error); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 132; goto __pyx_L1;}
  __pyx_1 = PyObject_CallObject(__pyx_3, 0); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 132; goto __pyx_L1;}
  Py_DECREF(__pyx_3); __pyx_3 = 0;
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_4);
  __Pyx_AddTraceback("sound.set_volume");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_channel);
  Py_DECREF(__pyx_v_volume);
  return __pyx_r;
}

static PyObject *__pyx_f_5sound_set_pan(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_5sound_set_pan(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_channel = 0;
  PyObject *__pyx_v_pan = 0;
  PyObject *__pyx_v_delay = 0;
  PyObject *__pyx_r;
  int __pyx_1;
  float __pyx_2;
  float __pyx_3;
  PyObject *__pyx_4 = 0;
  PyObject *__pyx_5 = 0;
  static char *__pyx_argnames[] = {"channel","pan","delay",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "OOO", __pyx_argnames, &__pyx_v_channel, &__pyx_v_pan, &__pyx_v_delay)) return 0;
  Py_INCREF(__pyx_v_channel);
  Py_INCREF(__pyx_v_pan);
  Py_INCREF(__pyx_v_delay);

  /* "/home/tom/ab/renpy/module/sound.pyx":135 */
  __pyx_1 = PyInt_AsLong(__pyx_v_channel); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 135; goto __pyx_L1;}
  __pyx_2 = PyFloat_AsDouble(__pyx_v_pan); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 135; goto __pyx_L1;}
  __pyx_3 = PyFloat_AsDouble(__pyx_v_delay); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 135; goto __pyx_L1;}
  PSS_set_pan(__pyx_1,__pyx_2,__pyx_3);

  /* "/home/tom/ab/renpy/module/sound.pyx":136 */
  __pyx_4 = __Pyx_GetName(__pyx_m, __pyx_n_check_error); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 136; goto __pyx_L1;}
  __pyx_5 = PyObject_CallObject(__pyx_4, 0); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 136; goto __pyx_L1;}
  Py_DECREF(__pyx_4); __pyx_4 = 0;
  Py_DECREF(__pyx_5); __pyx_5 = 0;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_4);
  Py_XDECREF(__pyx_5);
  __Pyx_AddTraceback("sound.set_pan");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_channel);
  Py_DECREF(__pyx_v_pan);
  Py_DECREF(__pyx_v_delay);
  return __pyx_r;
}

static PyObject *__pyx_f_5sound_set_secondary_volume(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_5sound_set_secondary_volume(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_channel = 0;
  PyObject *__pyx_v_volume = 0;
  PyObject *__pyx_v_delay = 0;
  PyObject *__pyx_r;
  int __pyx_1;
  float __pyx_2;
  float __pyx_3;
  PyObject *__pyx_4 = 0;
  PyObject *__pyx_5 = 0;
  static char *__pyx_argnames[] = {"channel","volume","delay",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "OOO", __pyx_argnames, &__pyx_v_channel, &__pyx_v_volume, &__pyx_v_delay)) return 0;
  Py_INCREF(__pyx_v_channel);
  Py_INCREF(__pyx_v_volume);
  Py_INCREF(__pyx_v_delay);

  /* "/home/tom/ab/renpy/module/sound.pyx":139 */
  __pyx_1 = PyInt_AsLong(__pyx_v_channel); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 139; goto __pyx_L1;}
  __pyx_2 = PyFloat_AsDouble(__pyx_v_volume); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 139; goto __pyx_L1;}
  __pyx_3 = PyFloat_AsDouble(__pyx_v_delay); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 139; goto __pyx_L1;}
  PSS_set_secondary_volume(__pyx_1,__pyx_2,__pyx_3);

  /* "/home/tom/ab/renpy/module/sound.pyx":140 */
  __pyx_4 = __Pyx_GetName(__pyx_m, __pyx_n_check_error); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 140; goto __pyx_L1;}
  __pyx_5 = PyObject_CallObject(__pyx_4, 0); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 140; goto __pyx_L1;}
  Py_DECREF(__pyx_4); __pyx_4 = 0;
  Py_DECREF(__pyx_5); __pyx_5 = 0;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_4);
  Py_XDECREF(__pyx_5);
  __Pyx_AddTraceback("sound.set_secondary_volume");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_channel);
  Py_DECREF(__pyx_v_volume);
  Py_DECREF(__pyx_v_delay);
  return __pyx_r;
}

static PyObject *__pyx_f_5sound_set_end_event(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_5sound_set_end_event(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_channel = 0;
  PyObject *__pyx_v_event = 0;
  PyObject *__pyx_r;
  int __pyx_1;
  int __pyx_2;
  PyObject *__pyx_3 = 0;
  PyObject *__pyx_4 = 0;
  static char *__pyx_argnames[] = {"channel","event",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "OO", __pyx_argnames, &__pyx_v_channel, &__pyx_v_event)) return 0;
  Py_INCREF(__pyx_v_channel);
  Py_INCREF(__pyx_v_event);

  /* "/home/tom/ab/renpy/module/sound.pyx":143 */
  __pyx_1 = PyInt_AsLong(__pyx_v_channel); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 143; goto __pyx_L1;}
  __pyx_2 = PyInt_AsLong(__pyx_v_event); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 143; goto __pyx_L1;}
  PSS_set_endevent(__pyx_1,__pyx_2);

  /* "/home/tom/ab/renpy/module/sound.pyx":144 */
  __pyx_3 = __Pyx_GetName(__pyx_m, __pyx_n_check_error); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 144; goto __pyx_L1;}
  __pyx_4 = PyObject_CallObject(__pyx_3, 0); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 144; goto __pyx_L1;}
  Py_DECREF(__pyx_3); __pyx_3 = 0;
  Py_DECREF(__pyx_4); __pyx_4 = 0;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_4);
  __Pyx_AddTraceback("sound.set_end_event");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_channel);
  Py_DECREF(__pyx_v_event);
  return __pyx_r;
}

static PyObject *__pyx_f_5sound_get_volume(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_5sound_get_volume(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_channel = 0;
  PyObject *__pyx_r;
  int __pyx_1;
  PyObject *__pyx_2 = 0;
  static char *__pyx_argnames[] = {"channel",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O", __pyx_argnames, &__pyx_v_channel)) return 0;
  Py_INCREF(__pyx_v_channel);
  __pyx_1 = PyInt_AsLong(__pyx_v_channel); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 147; goto __pyx_L1;}
  __pyx_2 = PyFloat_FromDouble(PSS_get_volume(__pyx_1)); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 147; goto __pyx_L1;}
  __pyx_r = __pyx_2;
  __pyx_2 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  __Pyx_AddTraceback("sound.get_volume");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_channel);
  return __pyx_r;
}

static PyObject *__pyx_f_5sound_init(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_5sound_init(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_freq = 0;
  PyObject *__pyx_v_stereo = 0;
  PyObject *__pyx_v_samples = 0;
  PyObject *__pyx_v_status = 0;
  PyObject *__pyx_r;
  int __pyx_1;
  PyObject *__pyx_2 = 0;
  int __pyx_3;
  int __pyx_4;
  int __pyx_5;
  PyObject *__pyx_6 = 0;
  static char *__pyx_argnames[] = {"freq","stereo","samples","status",0};
  __pyx_v_status = __pyx_k7;
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "OOO|O", __pyx_argnames, &__pyx_v_freq, &__pyx_v_stereo, &__pyx_v_samples, &__pyx_v_status)) return 0;
  Py_INCREF(__pyx_v_freq);
  Py_INCREF(__pyx_v_stereo);
  Py_INCREF(__pyx_v_samples);
  Py_INCREF(__pyx_v_status);

  /* "/home/tom/ab/renpy/module/sound.pyx":150 */
  __pyx_1 = PyObject_IsTrue(__pyx_v_status); if (__pyx_1 < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 150; goto __pyx_L1;}
  if (__pyx_1) {
    __pyx_2 = PyInt_FromLong(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 151; goto __pyx_L1;}
    Py_DECREF(__pyx_v_status);
    __pyx_v_status = __pyx_2;
    __pyx_2 = 0;
    goto __pyx_L2;
  }
  /*else*/ {
    __pyx_2 = PyInt_FromLong(0); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 153; goto __pyx_L1;}
    Py_DECREF(__pyx_v_status);
    __pyx_v_status = __pyx_2;
    __pyx_2 = 0;
  }
  __pyx_L2:;

  /* "/home/tom/ab/renpy/module/sound.pyx":155 */
  __pyx_1 = PyInt_AsLong(__pyx_v_freq); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 155; goto __pyx_L1;}
  __pyx_3 = PyInt_AsLong(__pyx_v_stereo); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 155; goto __pyx_L1;}
  __pyx_4 = PyInt_AsLong(__pyx_v_samples); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 155; goto __pyx_L1;}
  __pyx_5 = PyInt_AsLong(__pyx_v_status); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 155; goto __pyx_L1;}
  PSS_init(__pyx_1,__pyx_3,__pyx_4,__pyx_5);

  /* "/home/tom/ab/renpy/module/sound.pyx":156 */
  __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n_check_error); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 156; goto __pyx_L1;}
  __pyx_6 = PyObject_CallObject(__pyx_2, 0); if (!__pyx_6) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 156; goto __pyx_L1;}
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  Py_DECREF(__pyx_6); __pyx_6 = 0;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_6);
  __Pyx_AddTraceback("sound.init");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_freq);
  Py_DECREF(__pyx_v_stereo);
  Py_DECREF(__pyx_v_samples);
  Py_DECREF(__pyx_v_status);
  return __pyx_r;
}

static PyObject *__pyx_f_5sound_quit(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_5sound_quit(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  PSS_quit();

  __pyx_r = Py_None; Py_INCREF(Py_None);
  return __pyx_r;
}

static PyObject *__pyx_f_5sound_periodic(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_5sound_periodic(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  PSS_periodic();

  __pyx_r = Py_None; Py_INCREF(Py_None);
  return __pyx_r;
}

static PyObject *__pyx_f_5sound_alloc_event(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_5sound_alloc_event(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_surf = 0;
  PyObject *__pyx_r;
  static char *__pyx_argnames[] = {"surf",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O", __pyx_argnames, &__pyx_v_surf)) return 0;
  Py_INCREF(__pyx_v_surf);
  PSS_alloc_event(__pyx_v_surf);

  __pyx_r = Py_None; Py_INCREF(Py_None);
  Py_DECREF(__pyx_v_surf);
  return __pyx_r;
}

static PyObject *__pyx_f_5sound_refresh_event(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_5sound_refresh_event(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  PSS_refresh_event();

  __pyx_r = Py_None; Py_INCREF(Py_None);
  return __pyx_r;
}

static PyObject *__pyx_k9p;

static char __pyx_k9[] = "pysdlsound version mismatch.";

static PyObject *__pyx_f_5sound_check_version(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_5sound_check_version(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_version = 0;
  PyObject *__pyx_r;
  int __pyx_1;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  static char *__pyx_argnames[] = {"version",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O", __pyx_argnames, &__pyx_v_version)) return 0;
  Py_INCREF(__pyx_v_version);
  __pyx_2 = PyInt_FromLong(2); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 171; goto __pyx_L1;}
  if (PyObject_Cmp(__pyx_v_version, __pyx_2, &__pyx_1) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 171; goto __pyx_L1;}
  __pyx_1 = __pyx_1 < 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  if (!__pyx_1) {
    __pyx_2 = PyInt_FromLong(4); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 171; goto __pyx_L1;}
    if (PyObject_Cmp(__pyx_v_version, __pyx_2, &__pyx_1) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 171; goto __pyx_L1;}
    __pyx_1 = __pyx_1 > 0;
    Py_DECREF(__pyx_2); __pyx_2 = 0;
  }
  if (__pyx_1) {
    __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 172; goto __pyx_L1;}
    Py_INCREF(__pyx_k9p);
    PyTuple_SET_ITEM(__pyx_2, 0, __pyx_k9p);
    __pyx_3 = PyObject_CallObject(PyExc_Exception, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 172; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    __Pyx_Raise(__pyx_3, 0, 0);
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    {__pyx_filename = __pyx_f[0]; __pyx_lineno = 172; goto __pyx_L1;}
    goto __pyx_L2;
  }
  __pyx_L2:;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  __Pyx_AddTraceback("sound.check_version");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_version);
  return __pyx_r;
}

static __Pyx_InternTabEntry __pyx_intern_tab[] = {
  {&__pyx_n_check_error, "check_error"},
  {0, 0}
};

static __Pyx_StringTabEntry __pyx_string_tab[] = {
  {&__pyx_k8p, __pyx_k8, sizeof(__pyx_k8)},
  {&__pyx_k9p, __pyx_k9, sizeof(__pyx_k9)},
  {0, 0, 0}
};

static struct PyMethodDef __pyx_methods[] = {
  {"check_error", (PyCFunction)__pyx_f_5sound_check_error, METH_VARARGS|METH_KEYWORDS, 0},
  {"play", (PyCFunction)__pyx_f_5sound_play, METH_VARARGS|METH_KEYWORDS, 0},
  {"queue", (PyCFunction)__pyx_f_5sound_queue, METH_VARARGS|METH_KEYWORDS, 0},
  {"stop", (PyCFunction)__pyx_f_5sound_stop, METH_VARARGS|METH_KEYWORDS, 0},
  {"dequeue", (PyCFunction)__pyx_f_5sound_dequeue, METH_VARARGS|METH_KEYWORDS, 0},
  {"queue_depth", (PyCFunction)__pyx_f_5sound_queue_depth, METH_VARARGS|METH_KEYWORDS, 0},
  {"playing_name", (PyCFunction)__pyx_f_5sound_playing_name, METH_VARARGS|METH_KEYWORDS, 0},
  {"pause", (PyCFunction)__pyx_f_5sound_pause, METH_VARARGS|METH_KEYWORDS, 0},
  {"unpause", (PyCFunction)__pyx_f_5sound_unpause, METH_VARARGS|METH_KEYWORDS, 0},
  {"unpause_all", (PyCFunction)__pyx_f_5sound_unpause_all, METH_VARARGS|METH_KEYWORDS, 0},
  {"fadeout", (PyCFunction)__pyx_f_5sound_fadeout, METH_VARARGS|METH_KEYWORDS, 0},
  {"busy", (PyCFunction)__pyx_f_5sound_busy, METH_VARARGS|METH_KEYWORDS, 0},
  {"get_pos", (PyCFunction)__pyx_f_5sound_get_pos, METH_VARARGS|METH_KEYWORDS, 0},
  {"set_volume", (PyCFunction)__pyx_f_5sound_set_volume, METH_VARARGS|METH_KEYWORDS, 0},
  {"set_pan", (PyCFunction)__pyx_f_5sound_set_pan, METH_VARARGS|METH_KEYWORDS, 0},
  {"set_secondary_volume", (PyCFunction)__pyx_f_5sound_set_secondary_volume, METH_VARARGS|METH_KEYWORDS, 0},
  {"set_end_event", (PyCFunction)__pyx_f_5sound_set_end_event, METH_VARARGS|METH_KEYWORDS, 0},
  {"get_volume", (PyCFunction)__pyx_f_5sound_get_volume, METH_VARARGS|METH_KEYWORDS, 0},
  {"init", (PyCFunction)__pyx_f_5sound_init, METH_VARARGS|METH_KEYWORDS, 0},
  {"quit", (PyCFunction)__pyx_f_5sound_quit, METH_VARARGS|METH_KEYWORDS, 0},
  {"periodic", (PyCFunction)__pyx_f_5sound_periodic, METH_VARARGS|METH_KEYWORDS, 0},
  {"alloc_event", (PyCFunction)__pyx_f_5sound_alloc_event, METH_VARARGS|METH_KEYWORDS, 0},
  {"refresh_event", (PyCFunction)__pyx_f_5sound_refresh_event, METH_VARARGS|METH_KEYWORDS, 0},
  {"check_version", (PyCFunction)__pyx_f_5sound_check_version, METH_VARARGS|METH_KEYWORDS, 0},
  {0, 0, 0, 0}
};

static void __pyx_init_filenames(void); /*proto*/

PyMODINIT_FUNC initsound(void); /*proto*/
PyMODINIT_FUNC initsound(void) {
  PyObject *__pyx_1 = 0;
  PyObject *__pyx_2 = 0;
  __pyx_init_filenames();
  __pyx_m = Py_InitModule4("sound", __pyx_methods, 0, 0, PYTHON_API_VERSION);
  if (!__pyx_m) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 23; goto __pyx_L1;};
  Py_INCREF(__pyx_m);
  __pyx_b = PyImport_AddModule("__builtin__");
  if (!__pyx_b) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 23; goto __pyx_L1;};
  if (PyObject_SetAttrString(__pyx_m, "__builtins__", __pyx_b) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 23; goto __pyx_L1;};
  if (__Pyx_InternStrings(__pyx_intern_tab) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 23; goto __pyx_L1;};
  if (__Pyx_InitStrings(__pyx_string_tab) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 23; goto __pyx_L1;};

  /* "/home/tom/ab/renpy/module/sound.pyx":58 */
  Py_INCREF(Py_False);
  __pyx_k1 = Py_False;
  __pyx_1 = PyInt_FromLong(0); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 58; goto __pyx_L1;}
  __pyx_k2 = __pyx_1;
  __pyx_1 = 0;
  Py_INCREF(Py_False);
  __pyx_k3 = Py_False;

  /* "/home/tom/ab/renpy/module/sound.pyx":79 */
  __pyx_2 = PyInt_FromLong(0); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 79; goto __pyx_L1;}
  __pyx_k4 = __pyx_2;
  __pyx_2 = 0;
  Py_INCREF(Py_False);
  __pyx_k5 = Py_False;

  /* "/home/tom/ab/renpy/module/sound.pyx":96 */
  Py_INCREF(Py_False);
  __pyx_k6 = Py_False;

  /* "/home/tom/ab/renpy/module/sound.pyx":149 */
  Py_INCREF(Py_False);
  __pyx_k7 = Py_False;

  /* "/home/tom/ab/renpy/module/sound.pyx":170 */
  return;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_2);
  __Pyx_AddTraceback("sound");
}

static char *__pyx_filenames[] = {
  "sound.pyx",
};

/* Runtime support code */

static void __pyx_init_filenames(void) {
  __pyx_f = __pyx_filenames;
}

static void __Pyx_Raise(PyObject *type, PyObject *value, PyObject *tb) {
    Py_XINCREF(type);
    Py_XINCREF(value);
    Py_XINCREF(tb);
    /* First, check the traceback argument, replacing None with NULL. */
    if (tb == Py_None) {
        Py_DECREF(tb);
        tb = 0;
    }
    else if (tb != NULL && !PyTraceBack_Check(tb)) {
        PyErr_SetString(PyExc_TypeError,
            "raise: arg 3 must be a traceback or None");
        goto raise_error;
    }
    /* Next, replace a missing value with None */
    if (value == NULL) {
        value = Py_None;
        Py_INCREF(value);
    }
    #if PY_VERSION_HEX < 0x02050000
    if (!PyClass_Check(type))
    #else
    if (!PyType_Check(type))
    #endif
    {
        /* Raising an instance.  The value should be a dummy. */
        if (value != Py_None) {
            PyErr_SetString(PyExc_TypeError,
                "instance exception may not have a separate value");
            goto raise_error;
        }
        /* Normalize to raise <class>, <instance> */
        Py_DECREF(value);
        value = type;
        #if PY_VERSION_HEX < 0x02050000
            if (PyInstance_Check(type)) {
                type = (PyObject*) ((PyInstanceObject*)type)->in_class;
                Py_INCREF(type);
            }
            else {
                PyErr_SetString(PyExc_TypeError,
                    "raise: exception must be an old-style class or instance");
                goto raise_error;
            }
        #else
            type = (PyObject*) type->ob_type;
            Py_INCREF(type);
            if (!PyType_IsSubtype((PyTypeObject *)type, (PyTypeObject *)PyExc_BaseException)) {
                PyErr_SetString(PyExc_TypeError,
                    "raise: exception class must be a subclass of BaseException");
                goto raise_error;
            }
        #endif
    }
    PyErr_Restore(type, value, tb);
    return;
raise_error:
    Py_XDECREF(value);
    Py_XDECREF(type);
    Py_XDECREF(tb);
    return;
}

static PyObject *__Pyx_GetName(PyObject *dict, PyObject *name) {
    PyObject *result;
    result = PyObject_GetAttr(dict, name);
    if (!result)
        PyErr_SetObject(PyExc_NameError, name);
    return result;
}

static int __Pyx_InternStrings(__Pyx_InternTabEntry *t) {
    while (t->p) {
        *t->p = PyString_InternFromString(t->s);
        if (!*t->p)
            return -1;
        ++t;
    }
    return 0;
}

static int __Pyx_InitStrings(__Pyx_StringTabEntry *t) {
    while (t->p) {
        *t->p = PyString_FromStringAndSize(t->s, t->n - 1);
        if (!*t->p)
            return -1;
        ++t;
    }
    return 0;
}

#include "compile.h"
#include "frameobject.h"
#include "traceback.h"

static void __Pyx_AddTraceback(char *funcname) {
    PyObject *py_srcfile = 0;
    PyObject *py_funcname = 0;
    PyObject *py_globals = 0;
    PyObject *empty_tuple = 0;
    PyObject *empty_string = 0;
    PyCodeObject *py_code = 0;
    PyFrameObject *py_frame = 0;
    
    py_srcfile = PyString_FromString(__pyx_filename);
    if (!py_srcfile) goto bad;
    py_funcname = PyString_FromString(funcname);
    if (!py_funcname) goto bad;
    py_globals = PyModule_GetDict(__pyx_m);
    if (!py_globals) goto bad;
    empty_tuple = PyTuple_New(0);
    if (!empty_tuple) goto bad;
    empty_string = PyString_FromString("");
    if (!empty_string) goto bad;
    py_code = PyCode_New(
        0,            /*int argcount,*/
        0,            /*int nlocals,*/
        0,            /*int stacksize,*/
        0,            /*int flags,*/
        empty_string, /*PyObject *code,*/
        empty_tuple,  /*PyObject *consts,*/
        empty_tuple,  /*PyObject *names,*/
        empty_tuple,  /*PyObject *varnames,*/
        empty_tuple,  /*PyObject *freevars,*/
        empty_tuple,  /*PyObject *cellvars,*/
        py_srcfile,   /*PyObject *filename,*/
        py_funcname,  /*PyObject *name,*/
        __pyx_lineno,   /*int firstlineno,*/
        empty_string  /*PyObject *lnotab*/
    );
    if (!py_code) goto bad;
    py_frame = PyFrame_New(
        PyThreadState_Get(), /*PyThreadState *tstate,*/
        py_code,             /*PyCodeObject *code,*/
        py_globals,          /*PyObject *globals,*/
        0                    /*PyObject *locals*/
    );
    if (!py_frame) goto bad;
    py_frame->f_lineno = __pyx_lineno;
    PyTraceBack_Here(py_frame);
bad:
    Py_XDECREF(py_srcfile);
    Py_XDECREF(py_funcname);
    Py_XDECREF(empty_tuple);
    Py_XDECREF(empty_string);
    Py_XDECREF(py_code);
    Py_XDECREF(py_frame);
}
